﻿Imports System.ComponentModel
Imports System.Drawing
Public Class TBPrimos
    ' el miembro m_estado se usa para indicar si el número es primo
    Private m_estado As Boolean = False

    <DefaultValue(False)> _
 Public ReadOnly Property Estado() As Boolean

        ' para saber si el número es primo
        Get
            Estado = m_estado
        End Get

    End Property
    Private Sub TBPrimos_KeyPress(ByVal sender As Object, _
        ByVal e As System.Windows.Forms.KeyPressEventArgs) _
        Handles TextBox1.KeyPress

        ' se verifica que las teclas pulsadas
        ' sean numéricas
        ' en caso contrario se rechaza la tecla
        Dim Tecla As Integer
        Tecla = Asc(e.KeyChar)
        Select Case Tecla
            Case 48 To 57
            Case Else
                Tecla = 0
        End Select

        ' se rechaza o acepta la tecla
        If Tecla = 0 Then
            e.Handled = True
        Else
            e.Handled = False
        End If

    End Sub
    Private Sub TBPrimos_TextChanged(ByVal sender As Object, _
         ByVal e As System.EventArgs) _
         Handles TextBox1.TextChanged

        ' cada vez que cambia el cuadro de texto se verifica
        ' si el número es o no es primo
        If Primo(CLng(TextBox1.Text)) Then
            ' si es primo se pinta de verde
            TextBox1.ForeColor = Color.Green
            m_estado = True
        Else
            ' si no es primo, se pinta de rojo
            TextBox1.ForeColor = Color.Red
            m_estado = False
        End If

    End Sub
    Private Function Primo(ByVal v As Long) As Boolean
        Dim i As Long

        ' rutina de cálculo de primo
        ' muy mejorable, ya que con números grandes
        ' se hace lenta

        Primo = False
        If v < 3 Then
            Primo = True
            Exit Function
        End If
        For i = 2 To (v / 2)
            ' si el resto es cero: no es primo 
            If v Mod i = 0 Then Exit Function
        Next
        Primo = True

    End Function

    Public Sub Limpiar()

        ' limpia el cuadro de texto
        ' método público
        TextBox1.Text = "0"

    End Sub
End Class
