﻿Public Class Empleado
    'Propiedades privadas
    Private Nombre As String
    Private NúmeroEmpleado As String
    Private Dirección As String
    Private Sección As String
    Private Sueldo As Double
    Public Sub New()

    End Sub
    Public Sub New(ByVal strNombre As String, ByVal strNúmeroEmpleado As String, _
    ByVal strDirección As String, ByVal strSección As String, _
    ByVal dblSueldo As Double)

        asignarNombre(strNombre)
        asignarNúmeroEmpleado(strNúmeroEmpleado)
        asignarDirección(strDirección)
        asignarSección(strSección)
        asignarSueldo(dblSueldo)

    End Sub
    'Métodos públicos
    Public Function leerNombre() As String
        Return Nombre
    End Function
    Public Sub asignarNombre(ByVal strNombre As String)
        If strNombre.Length = 0 Then
            Informar("cadena vacía")
        ElseIf StrComp(strNombre, Nombre, CompareMethod.Binary) = 0 Then
            Informar("No hubo cambios")
        Else
            Nombre = strNombre
        End If
    End Sub
    Public Function leerNúmeroEmpleado() As String
        Return NúmeroEmpleado
    End Function
    Public Sub asignarNúmeroEmpleado(ByVal strNúmeroEmpleado As String)
        If strNúmeroEmpleado.Length = 0 Then
            Informar("cadena vacía")
        ElseIf StrComp(strNúmeroEmpleado, NúmeroEmpleado, CompareMethod.Binary) = 0 Then
            Informar("No hubo cambios")
        Else
            NúmeroEmpleado = strNúmeroEmpleado
        End If
    End Sub
    Public Function leerDirección() As String
        Return Dirección
    End Function
    Public Sub asignarDirección(ByVal strDirección As String)
        If strDirección.Length = 0 Then
            Informar("cadena vacía")
        ElseIf StrComp(strDirección, Dirección, CompareMethod.Binary) = 0 Then
            Informar("No hubo cambios")
        Else
            Dirección = strDirección
        End If
    End Sub
    Public Function leerSección() As String
        Return Sección
    End Function
    Public Sub asignarSección(ByVal strSección As String)
        If strSección.Length = 0 Then
            Informar("cadena vacía")
        ElseIf StrComp(strSección, Sección, CompareMethod.Binary) = 0 Then
            Informar("No hubo cambios")
        Else
            Sección = strSección
        End If
    End Sub
    Public Function leerSueldo() As Double
        Return Sueldo
    End Function
    Public Sub asignarSueldo(ByVal dblSueldo As Double)
        If dblSueldo < 0 Then
            Informar("importe negativo")
        Else
            Sueldo = dblSueldo
        End If
    End Sub
    Public Sub ImprimirEmpleado()

        Informar("Nombre " & Nombre)
        Informar("Número de empleado " & NúmeroEmpleado)
        Informar("Dirección " & Dirección)
        Informar("Sección " & Sección)
        Informar("Sueldo " & Sueldo)

    End Sub
    ' Protected: Método privado para todos menos
    ' para la propia clase y sus clases derivadas
    Protected Sub Informar(ByVal strMensaje As String)
        ' método privado sólo accesible desde dentro de 
        ' la clase Empleado
        System.Console.WriteLine(strMensaje)
    End Sub
End Class


