﻿Module Module1
    ' Unidad06 Ej03
    ' Estudio del pase de objetos en modo ByVal y ByRef
    ' toda clase de objetos salvo la clase String

    Class MiClase
        Public I1 As Integer
    End Class

    Public Sub FuncByVal(ByVal S4 As MiClase)
        S4.I1 = 20
    End Sub

    Public Sub FuncByValNew(ByVal S4 As MiClase)
        S4 = New MiClase()
        S4.I1 = 40
        Debug.WriteLine("Dentro de Función " + S4.I1.ToString)
    End Sub

    Public Sub FuncByRef(ByRef S4 As MiClase)
        S4.I1 = 30
    End Sub

    Public Sub FuncByRefNew(ByRef S4 As MiClase)
        S4 = New MiClase()
        S4.I1 = 50
        Debug.WriteLine("Dentro de Función " + S4.I1.ToString)
    End Sub

    Public Sub Main()
        Dim S40 As New MiClase()
        Dim S41 As MiClase = S40
        S40.I1 = 10

        Debug.WriteLine("Objetos como parámetros:  Estado inicial")
        Debug.WriteLine("¿Son el mismo objeto?" + _
            (S40 Is S41).ToString())
        Debug.WriteLine("S40.I1 es " + S40.I1.ToString())
        Debug.WriteLine("S41.I1 es " + S41.I1.ToString())


        ' primer caso
        Debug.WriteLine("Primer caso: ByVal")
        FuncByVal(S41)
        Debug.WriteLine("¿Son el mismo objeto?" + _
            (S40 Is S41).ToString())
        Debug.WriteLine("S40.I1 es " + S40.I1.ToString())
        Debug.WriteLine("S41.I1 es " + S41.I1.ToString())

        ' segundo caso
        Debug.WriteLine("Segundo caso: ByRef")
        FuncByRef(S41)
        Debug.WriteLine("¿Son el mismo objeto?" + _
             (S40 Is S41).ToString())
        Debug.WriteLine("S40.I1 es " + S40.I1.ToString())
        Debug.WriteLine("S41.I1 es " + S41.I1.ToString())

        ' tercer caso
        Debug.WriteLine("Tercer caso: ByVal con New")
        FuncByValNew(S41)
        Debug.WriteLine("¿Son el mismo objeto?" + _
              (S40 Is S41).ToString())
        Debug.WriteLine("S40.I1 es " + S40.I1.ToString())
        Debug.WriteLine("S41.I1 es " + S41.I1.ToString())

        ' cuarto caso
        Debug.WriteLine("Cuarto caso: ByRef con New")
        FuncByRefNew(S41)
        Debug.WriteLine("¿Son el mismo objeto?" + _
              (S40 Is S41).ToString())
        Debug.WriteLine("S40.I1 es " + S40.I1.ToString())
        Debug.WriteLine("S41.I1 es " + S41.I1.ToString())


    End Sub

End Module