﻿Option Compare Text
Module Module1

    ' Unidad 06 Ej 04
    Sub Main()
        Dim dblV1 As Double
        dblV1 = (-3) ^ 4                  'Resultado  81
        Debug.WriteLine("1." + CStr(dblV1))
        dblV1 = -3 ^ 4                    'Resultado -81
        Debug.WriteLine("2." + CStr(dblV1))

        ' Estas dos operaciones son equivalentes
        ' dblV1 = dblV1 / 4
        dblV1 /= 4
        Debug.WriteLine("3." + CStr(dblV1))

        ' Estas dos operaciones son equivalentes
        ' dblV1 = dblV1 + 4
        dblV1 += 4
        Debug.WriteLine("4." + CStr(dblV1))

        dblV1 = (1 / 2) ^ 3 + 5 * 3       'Resultado 15,125
        ' Esto se resuelve en esta secuencia
        '1/2  que es 0,5
        '0,5 elevado al cubo que es 0,125
        '5 * 3 que es 15
        '0, 125 + 15 que es 15,125
        Debug.WriteLine("5." + CStr(dblV1))

        ' División entera
        Dim intV1 As Integer = 40
        Dim dblV2 As Double = 3.4
        ' Al ser un valor Double se realiza una conversión a
        ' entero (se toma el valor 3), si fuese 3.5 toma el valor 4
        ' Esto sólo funciona si Option Strict Off 
        '(¡no recomendable!)
        ' Con Option Strict On daría error de compilación
        intV1 \= dblV2                       'Resultado 13
        Debug.WriteLine("6." + CStr(intV1))

        dblV2 = 13.5 Mod 3                   ' Resultado 1.5
        Debug.WriteLine("7." + CStr(dblV2))

        ' Concatenación
        Dim strV1 As String = "Visual Basic "
        Dim strV2 As String = ".NET"
        strV1 &= strV2             ' Resultado "Visual Basic .NET"
        Debug.WriteLine("8." + strV1)

        ' Comparaciones
        Dim bV1 As Boolean
        bV1 = 30 > 40                        ' Resultado False
        Debug.WriteLine("9." + bV1.ToString)

        bV1 = "66" > "0000"                 ' Resultado True
        Debug.WriteLine("10." + bV1.ToString)

        ' Estas comparaciones requieren
        'Option Compare Binary ' Determina cómo se comparan Strings

        ' Considera el orden ASCII donde
        ' A > a, B > b, C > c
        bV1 = "c" > "A"                      ' Resultado True
        Debug.WriteLine("11." + bV1.ToString)
        bV1 = "c" > "C"                      ' Resultado True
        Debug.WriteLine("12." + bV1.ToString)

        ' Estas comparaciones requieren
        'Option Compare Text   ' Determina cómo se comparan Strings
        ' Considera mayúsculas y minúsculas
        ' con el mismo orden
        bV1 = "c" > "A"                      ' Resultado True
        Debug.WriteLine("13." + bV1.ToString)
        bV1 = "c" > "C"                      ' Resultado False
        Debug.WriteLine("14." + bV1.ToString)

        ' uso de Like
        bV1 = "axxxxxa" Like "a*a"           'Resultado True
        Debug.WriteLine("15." + bV1.ToString)
        ' * significa comodín de caracteres 
        bV1 = "C" Like "[A-D]"               ' Resultado True
        Debug.WriteLine("16." + bV1.ToString)
        ' [ ] significa rango de caracteres
        bV1 = "C" Like "¡[A-D]"              ' Resultado False
        Debug.WriteLine("16b." + bV1.ToString)
        ' ¡ significa negación
        bV1 = "C" Like "D"                   ' Resultado False
        Debug.WriteLine("17." + bV1.ToString)
        bV1 = "C23" Like "[A-D]##"           ' Resultado True
        Debug.WriteLine("18." + bV1.ToString)
        ' # significa posiciones de dígitos
        bV1 = "C23" Like "?##"               ' Resultado True
        Debug.WriteLine("19." + bV1.ToString)
        ' ¿ significa un carácter cualquiera
        bV1 = "C23A" Like "[A-C]#*"        ' Resultado True
        Debug.WriteLine("20." + bV1.ToString)

        ' Uso de Is
        Dim miObj As New Object
        Dim miObj2 As Object
        miObj2 = miObj
        Dim miObj3 As New Object
        bV1 = miObj2 Is miObj              ' Resultado True
        Debug.WriteLine("21." + bV1.ToString)
        bV1 = miObj3 Is miObj              ' Resultado False
        Debug.WriteLine("22." + bV1.ToString)

        ' Operadores lógicos  y de bit
        Dim int1 As Integer = 6
        Dim int2 As Integer = 4
        ' Esta operación sólo es válida con Option Strict off 
        '(¡no recomendable!)
        bV1 = int1 And int2                 ' Resultado True
        Debug.WriteLine("23." + bV1.ToString)

        Dim int3 As Integer
        ' Estas operaciones son válidas incluso con Strict On
        int3 = int1 And int2       ' Resultado 4 (0110) And (0100)
        Debug.WriteLine("24." + CStr(int3))
        int3 = int1 Or int2        ' Resultado 6 (0110) Or (0100)
        Debug.WriteLine("25." + CStr(int3))
        int3 = int1 Xor int2       ' Resultado 2 (0110) Xor (0100)
        Debug.WriteLine("26." + CStr(int3))
        int3 = Not int1            ' Resultado -7  Not (0110) 
        Debug.WriteLine("27." + CStr(int3))

        ' Operaciones booleanas   
        ' 6 > 4 And 6 > -7 
        bV1 = int1 > int2 And int1 > int3       ' Resultado True: 
        Debug.WriteLine("28." + bV1.ToString)

        ' 6 > 4 AndAlso  6 < -7
        bV1 = int1 > int2 AndAlso int1 < int3   ' Resultado False:
        Debug.WriteLine("29." + bV1.ToString)

        ' 6 > 4 OrElse 6 > -7
        bV1 = int1 > int2 OrElse int1 > int3    ' Resultado True:
        Debug.WriteLine("30." + bV1.ToString)


    End Sub
End Module