﻿Imports System.IO
Imports System.Environment
Module Module1
    ' Unidad 10 Ej 03
    ' el espacio de nombres System.IO se importa para poder usar la 
    ' clase StreamWriter
    ' la clase  System.Environment se importa para usar NewLine

    Sub Main()
        ' flujo de caracteres
        Dim fc As StreamWriter
        ' nombre del archivo
        Dim sNom As String
        ' área de entrada desde la consola
        Dim sIn As String
        ' indicador si append o no
        Dim bAppend As Boolean = False


        ' Se encierra todo en un bloque Try 
        ' para gestionar los errores de modo personalizado
        Try
            ' Se obtiene el nombre del archivo de salida
            ' si ya existe lo sobreescribe o lo continua
            Console.Write("Nombre del archivo: ")
            sNom = Console.ReadLine()

            ' Continuación de archivo o lo escribe 
            ' desde el principio
            Console.WriteLine("Continua el archivo (C) o " & _
    "desde el inicio (Intro): ")
            sIn = Console.ReadLine()
            If sIn.Length > 0 Then bAppend = True

            ' Crea un flujo de caracteres para el archivo SNom   
            ' acceso: desde el inicio
            ' codificación: Unicode

            fc = New StreamWriter(sNom, bAppend, _
    System.Text.Encoding.ASCII)

            ' Introducción de datos desde la consola
            Console.Write("Introducir datos para el archivo " & _
    "{0},  Fin (Intro):" + NewLine + "> ", sNom)
            sIn = Console.ReadLine()

            ' si sólo se teclea Intro -> finaliza
            While (sIn.Length <> 0)
                ' escribe la línea en el registro de salida
                fc.WriteLine(sIn)

                ' vuelve a leer la consola
                Console.Write("> ")
                sIn = Console.ReadLine()
            End While


        Catch ex As IOException
            Console.WriteLine("Se detecta un error IO " + _
    ex.Message)
        Catch ex As Exception
            Console.WriteLine("Se detecta un error genérico " + _
    ex.Message)

        Finally
            ' Cerrar el flujo de caracteres que utiliza el archivo
            If (Not fc Is Nothing) Then fc.Close()
        End Try
        Console.Read()
    End Sub

End Module