﻿Imports System.IO
Module Module1
    ' Unidad 10 Ej 04
    Sub Main()
        Dim fb As FileStream
        Dim fc As StreamReader

        ' Variable para el nombre del archivo  
        Dim sNom As String
        ' Variable para el contenido del archivo  
        Dim sIn As String


        ' Se encierra todo en un bloque Try 
        ' para gestionar los errores de modo personalizado
        Try
            ' Se obtiene el nombre del archivo
            Console.Write("Nombre del archivo:")
            sNom = Console.ReadLine()

            ' Crea un flujo de bytes para el archivo texto.txt
            ' modo Open: si no existe genera un error  
            ' acceso: Read, para lectura

            fb = New FileStream(sNom, FileMode.Open, _
    FileAccess.Read)

            ' utilizo el objeto para crear un
            ' objeto StreamReader
            fc = New StreamReader(fb, System.Text.Encoding.Unicode)

            sIn = fc.ReadLine()
            While (sIn <> Nothing)

                ' ¿ qué leyó?
                Console.WriteLine("Leyó." + sIn)

                sIn = fc.ReadLine()

            End While


        Catch ex As IOException
            Console.WriteLine("Se detecta un error IO " + _
    ex.Message)
        Catch ex As Exception
            Console.WriteLine("Se detecta un error genérico " + _
    ex.Message)

        Finally
            ' Cerrar el flujo de datos que utiliza el archivo
            If (Not fc Is Nothing) Then fc.Close()
            If (Not fb Is Nothing) Then fb.Close()

        End Try
        Console.Read()
    End Sub

End Module