﻿Imports System.IO
Module Module1
    ' Unidad 10 Ej 05
    Sub Main()
        Dim fb As FileStream
        Dim fbw As BinaryWriter

        ' Variable para el nombre del archivo  
        Dim sNom As String

        Dim sIn As String
        Dim IIn As Integer

        ' Se encierra todo en un bloque Try 
        ' para gestionar los errores de modo personalizado
        Try
            ' Se obtiene el nombre del archivo
            Console.Write("Nombre del archivo:")
            sNom = Console.ReadLine()

            ' Crea un flujo de bytes para el archivo  
            ' modo Create: si existe lo sobrescribe  
            ' acceso: Write, para escritura

            fb = New FileStream(sNom, FileMode.Create, _
    FileAccess.Write)

            ' utilizo el objeto para crear un
            ' objeto BinaryWriter

            fbw = New BinaryWriter(fb, System.Text.Encoding.UTF8)

            Console.WriteLine("¿nombre del alumno? Fin (Intro)")
            sIn = Console.ReadLine()
            While (sIn <> Nothing)
                Console.Write("Número de legajo:")
                IIn = Convert.ToInt32(Console.ReadLine())

                ' escribe los datos en el flujo de salida 
                fbw.Write(sIn)
                fbw.Write(IIn)

                ' fuerza la escritura en este momento
                fbw.Flush()

                Console.WriteLine("¿Otro nombre? Fin (Intro)")
                sIn = Console.ReadLine()
            End While


        Catch ex As IOException
            Console.WriteLine("Se detecta un error IO " + _
    ex.Message)
        Catch ex As Exception
            Console.WriteLine("Se detecta un error genérico " + _
    ex.Message)

        Finally
            ' Cerrar el flujo de datos que utiliza el archivo
            If (Not fbw Is Nothing) Then fbw.Close()
            If (Not fb Is Nothing) Then fb.Close()

        End Try
        Console.Read()

    End Sub

End Module