﻿Imports System.IO
Module Module1
    ' Unidad 10 Ej 06
    Sub Main()
        Dim fb As FileStream
        Dim fbr As BinaryReader

        ' Variable para el nombre del archivo  
        Dim sNom As String
        ' Variables para el contenido de los datos  
        Dim sIn As String
        Dim iIn As Integer


        ' Se encierra todo en un bloque Try 
        ' para gestionar los errores de modo personalizado
        Try
            ' Se obtiene el nombre del archivo
            Console.Write("Nombre del archivo:")
            sNom = Console.ReadLine()

            ' Crea un flujo de bytes para el archivo texto.txt
            ' modo Open: si no existe genera un error  
            ' acceso: Read, para lectura

            fb = New FileStream(sNom, FileMode.Open, _
    FileAccess.Read)

            ' utilizo el objeto para crear un
            ' objeto BinaryReader
            fbr = New BinaryReader(fb, System.Text.Encoding.UTF8)


            While (fbr.PeekChar() <> -1)
                sIn = fbr.ReadString()
                iIn = fbr.ReadInt32

                Console.WriteLine("Datos leídos: Nombre: " & _
    "{0} Número:{1}", sIn, iIn.ToString())

            End While


        Catch ex As IOException
            Console.WriteLine("Se detecta un error IO " + _
   ex.Message)
        Catch ex As Exception
            Console.WriteLine("Se detecta un error genérico " + _
   ex.Message)

        Finally
            ' Cerrar el flujo de datos que utiliza el archivo
            If (Not fbr Is Nothing) Then fbr.Close()
            If (Not fb Is Nothing) Then fb.Close()

        End Try
        Console.Read()

    End Sub

End Module