﻿Public Class Form1
    ' Unidad14 Ej01
    ' uso de menú

    ' tamaño inicial de la letra
    Dim sizeStandard As Integer

    Private Sub AzulesToolStripMenuItem_Click(ByVal _
 sender As System.Object, _
    ByVal e As System.EventArgs) _
    Handles AzulesToolStripMenuItem.Click


        Panel1.BackColor = Color.Blue
        Panel2.BackColor = Color.LightBlue
        Label1.ForeColor = Color.Yellow
        Label2.ForeColor = Color.Yellow
        LimpiarMarcasColor()
        AzulesToolStripMenuItem.Checked = True

    End Sub

    Private Sub RojosToolStripMenuItem_Click(ByVal _
  sender As System.Object, _
    ByVal e As System.EventArgs) _
    Handles RojosToolStripMenuItem.Click

        Panel1.BackColor = Color.Red
        Panel2.BackColor = Color.LightPink
        Label1.ForeColor = Color.Black
        Label2.ForeColor = Color.Black
        LimpiarMarcasColor()
        RojosToolStripMenuItem.Checked = True

    End Sub

    Private Sub VerdesToolStripMenuItem_Click(ByVal _
  sender As System.Object, _
    ByVal e As System.EventArgs) _
    Handles VerdesToolStripMenuItem.Click

        Panel1.BackColor = Color.Green
        Panel2.BackColor = Color.LightGreen
        Label1.ForeColor = Color.Red
        Label2.ForeColor = Color.Red
        LimpiarMarcasColor()
        VerdesToolStripMenuItem.Checked = True

    End Sub

    Private Sub EspañolToolStripMenuItem_Click(ByVal _
  sender As System.Object, _
    ByVal e As System.EventArgs) _
    Handles EspañolToolStripMenuItem.Click

        Label1.Text = "Usuario"
        Label2.Text = "Contraseña"
        LimpiarMarcasIdioma()
        EspañolToolStripMenuItem.Checked = True

    End Sub

    Private Sub CatalánToolStripMenuItem_Click(ByVal _
  sender As System.Object, _
    ByVal e As System.EventArgs) _
    Handles CatalánToolStripMenuItem.Click

        Label1.Text = "Usuari"
        Label2.Text = "Clau"
        LimpiarMarcasIdioma()
        CatalánToolStripMenuItem.Checked = True

    End Sub

    Private Sub InglésToolStripMenuItem_Click(ByVal _
  sender As System.Object, _
    ByVal e As System.EventArgs) _
    Handles InglésToolStripMenuItem.Click

        Label1.Text = "User"
        Label2.Text = "Password"
        LimpiarMarcasIdioma()
        InglésToolStripMenuItem.Checked = True

    End Sub

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Valores iniciales
        Panel1.BackColor = Color.Blue
        Panel2.BackColor = Color.LightBlue
        Label1.ForeColor = Color.Yellow
        Label2.ForeColor = Color.Yellow
        Label1.Text = "Usuario"
        Label2.Text = "Contraseña"
        sizeStandard = TextBox2.Font.Size

    End Sub

    Public Sub LimpiarMarcasColor()

        RojosToolStripMenuItem.Checked = False
        AzulesToolStripMenuItem.Checked = False
        VerdesToolStripMenuItem.Checked = False

    End Sub

    Public Sub LimpiarMarcasIdioma()

        EspañolToolStripMenuItem.Checked = False
        CatalánToolStripMenuItem.Checked = False
        InglésToolStripMenuItem.Checked = False

    End Sub
    Private Sub AumentarLetraToolStripMenuItem_Click(ByVal _
   sender As System.Object, _
      ByVal e As System.EventArgs) _
      Handles AumentarLetraToolStripMenuItem.Click

        Dim sizeLetra As Single
        Dim familiaLetra As String
        sizeLetra = TextBox2.Font.Size
        familiaLetra = TextBox2.Font.Name
        sizeLetra += 1

        ' no permite aumentar por sobre 18 puntos
        If sizeLetra > 18 Then sizeLetra = 18
        TextBox2.Font = New Font(familiaLetra, sizeLetra)
        TextBox2.ForeColor = Color.Green

        ' informa el tamaño de la letra
        Label3.Text = sizeLetra.ToString & "puntos"

        ' si aumentó el tamaño aparece el
        ' menú para restablecer a 12 puntos
        If sizeLetra <> sizeStandard Then
            AñadirElementoMenú("Restablecer")
        End If

    End Sub


    Private Sub ReducirLetraToolStripMenuItem_Click(ByVal _
  sender As System.Object, _
    ByVal e As System.EventArgs) _
    Handles ReducirLetraToolStripMenuItem.Click

        Dim sizeLetra As Single
        Dim familiaLetra As String
        sizeLetra = TextBox2.Font.Size
        familiaLetra = TextBox2.Font.Name
        sizeLetra -= 1

        ' no permite reducir por debajo de puntos
        If sizeLetra < 8 Then sizeLetra = 8

        TextBox2.Font = New Font(familiaLetra, sizeLetra)
        TextBox2.ForeColor = Color.Red

        ' informa el tamaño de la letra
        Label3.Text = sizeLetra.ToString & "puntos"

        ' si redujo el tamaño aparece el
        ' menú para restablecer a 12 puntos
        If sizeLetra <> sizeStandard Then
            AñadirElementoMenú("Restablecer")
        End If

    End Sub
    ' Agrega un nuevo elemento de menú en ContextMenuStrip1
    Public Sub AñadirElementoMenú(ByVal ItemMenu As String)
        Dim ts As New ToolStripButton
        Dim listats As ToolStripItem

        ts.Text = ItemMenu

        ' Lo agrega al menú si ya no existe
        For Each listats In ContextMenuStrip1.Items
            If listats.Text = ItemMenu Then Exit Sub
        Next

        ContextMenuStrip1.Items.Add(ts)
        AddHandler ts.Click, AddressOf restablecer
        ContextMenuStrip1.Refresh()

    End Sub
    ' Este método gestiona el evento click 
    ' para restablecer la letra del cuadro de texto
    Private Sub restablecer(ByVal sender As System.Object, _
                                  ByVal e As System.EventArgs)

        Dim familiaLetra As String
        familiaLetra = TextBox2.Font.Name
        TextBox2.Font = New Font(familiaLetra, sizeStandard)
        Label3.Text = sizeStandard.ToString & "puntos"

        TextBox2.ForeColor = Color.Black

        ' cada vez que restablece a la fuente estándar 
        ' elimina del menú de contexto la posibilidad
        ' de restablecer 
        EliminarElementoMenú("Restablecer")


    End Sub
    ' Agrega un nuevo elemento de menú en ContextMenuStrip1
    Public Sub EliminarElementoMenú(ByVal ItemMenu As String)
        Dim ts As New ToolStripButton
        Dim listats As ToolStripItem
        ts.Text = ItemMenu

        ' Lo elimina del menú de contexto
        For Each listats In ContextMenuStrip1.Items
            If listats.Text = ItemMenu Then

                ' elimina la gestión del evento
                RemoveHandler ts.Click, AddressOf restablecer

                ' elimina el subelemento de menú
                ContextMenuStrip1.Items.Remove(listats)
                Exit Sub
            End If
        Next

    End Sub

End Class