﻿Public Class Form1

    ' Unidad15 Ej01

    Private Sub AbrirToolStripMenuItem_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) _
    Handles AbrirToolStripMenuItem.Click

        ' ejemplo uso OpenFileDialog

        OpenFileDialog1.InitialDirectory = "C:\"
        OpenFileDialog1.Filter = "Text files|*.txt|All files|*.*"
        OpenFileDialog1.FilterIndex = 1
        OpenFileDialog1.RestoreDirectory = True
        OpenFileDialog1.ShowDialog()

        ' si se seleccionó algún archivo
        If Not String.IsNullOrEmpty(OpenFileDialog1.FileName) Then
            ' al retornar habiendo seleccionado un archivo
            MessageBox.Show("Se eligió """ & OpenFileDialog1.FileName & """")
            Label1.Text = "Archivo abierto"
            TextBox1.Text = OpenFileDialog1.FileName

            '... lógicamente aquí se utiliza el nombre
            ' de archivo para abrir un archivo ...
        End If

    End Sub

    Private Sub GuardarComoToolStripMenuItem_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) _
    Handles GuardarComoToolStripMenuItem.Click

        ' ejemplo uso SaveFileDialog

        SaveFileDialog1.InitialDirectory = "C:\"
        SaveFileDialog1.Filter = "Text files|*.txt|All files|*.*"
        SaveFileDialog1.FilterIndex = 1
        SaveFileDialog1.RestoreDirectory = True
        SaveFileDialog1.ShowDialog()

        ' si se seleccionó algún archivo
        If Not String.IsNullOrEmpty(SaveFileDialog1.FileName) Then
            ' al retornar habiendo seleccionado un archivo
            MessageBox.Show("Se eligió """ & SaveFileDialog1.FileName & """")
            Label1.Text = "Archivo guardado"

            TextBox1.Text = SaveFileDialog1.FileName

            '... lógicamente aquí se utiliza el nombre
            ' de archivo para guardar un archivo ...
        End If


    End Sub

    Private Sub ColorDeFondoToolStripMenuItem_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) _
    Handles ColorDeFondoToolStripMenuItem.Click


        ' ejemplo uso ColorDialog

        ' cambia el color de fondo del formulario
        ColorDialog1.Color = Me.BackColor
        ColorDialog1.AllowFullOpen = True
        ColorDialog1.ShowDialog()

        Me.BackColor = ColorDialog1.Color

    End Sub

    Private Sub FuenteToolStripMenuItem_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) _
    Handles FuenteToolStripMenuItem.Click


        ' ejemplo uso FontDialog

        ' cambia la fuente del formulario
        FontDialog1.Font = Me.Font
        FontDialog1.ShowColor = True
        FontDialog1.ShowEffects = True
        FontDialog1.FixedPitchOnly = False
        FontDialog1.ShowDialog()

        ' asigna la fuente para el formulario
        Me.Font = FontDialog1.Font

    End Sub

    Private Sub ImprimirToolStripMenuItem_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) _
    Handles ImprimirToolStripMenuItem.Click


        ' ejemplo uso PrintDialog

        Dim ps As Printing.PrinterSettings
        PrintDialog1.AllowPrintToFile = True
        PrintDialog1.AllowCurrentPage = True
        PrintDialog1.AllowSelection = True
        PrintDialog1.AllowSomePages = True
        PrintDialog1.ShowHelp = True
        PrintDialog1.ShowNetwork = False
        PrintDialog1.ShowDialog()

        ps = PrintDialog1.PrinterSettings
        MsgBox("Se seleccionó la impresora " & ps.PrinterName)


    End Sub

    Private Sub SalirToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SalirToolStripMenuItem.Click

        ' Salir de la aplicación

        Me.Close()

    End Sub
End Class
