﻿
Partial Class _Default
    Inherits System.Web.UI.Page


    Protected Sub gvEmpleados_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles gvEmpleados.SelectedIndexChanged
        txtApellido.Text = gvEmpleados.SelectedRow.Cells(1).Text
        txtCiudad.Text = gvEmpleados.SelectedRow.Cells(3).Text
        txtPaís.Text = gvEmpleados.SelectedRow.Cells(4).Text
    End Sub


    Protected Sub gvRegión_RowDeleting(ByVal sender As Object, _
           ByVal e As System.Web.UI.WebControls.GridViewDeleteEventArgs) _
           Handles gvRegión.RowDeleting

        ' el evento RowDeleting ocurre antes que se efectúe
        ' la eliminación
        ' Por lo que se pueden incluir controles para cancelar el 
        ' proceso de la eliminación

        lblNota.Text = ""
        Dim Apellido As String = gvRegión.Rows(e.RowIndex).Cells(2).Text
        Dim Nombre As String = gvRegión.Rows(e.RowIndex).Cells(3).Text

        If Apellido = "Good" And Nombre = "Johnny" Then
            ' asi se corta el proceso de la eliminación
            e.Cancel = True
            lblNota.Text = "Este empleado no se puede eliminar"
        End If

    End Sub

    Protected Sub gvRegión_RowDeleted(ByVal sender As Object, _
     ByVal e As System.Web.UI.WebControls.GridViewDeletedEventArgs) _
     Handles gvRegión.RowDeleted

        ' el evento RowDeleted se produce en el retorno de 
        ' la eliminación
        ' si hay errores se puede emitir un mensaje de notificación
        ' e indicar que el error ya fue gestionado

        If e.Exception Is Nothing Then
            ' se eliminó el registro
            lblNota.Text = "Registro eliminado correctamente"
        Else
            lblNota.Text = "ERROR: No se pudo eliminar el registro"
            e.ExceptionHandled = True
        End If

    End Sub
    Protected Sub gvRegión_RowEditing(ByVal sender As Object, _
           ByVal e As System.Web.UI.WebControls.GridViewEditEventArgs) _
           Handles gvRegión.RowEditing

        ' comienza un proceso de modificación
        lblNota.Text = ""

    End Sub

    Protected Sub gvRegión_RowUpdated(ByVal sender As Object, _
        ByVal e As System.Web.UI.WebControls.GridViewUpdatedEventArgs) _
        Handles gvRegión.RowUpdated

        ' el proceso de modificación puede generar alguna excepción
        ' en tal caso, se gestiona la excepción y se emite
        ' un aviso que indique que hubo un error

        If Not e.Exception Is Nothing Then
            lblNota.Text = _
            "No se pudo modificar el registro en la base de datos"
            e.ExceptionHandled = True
        Else
            lblNota.Text = "Datos modificados correctamente."
        End If
    End Sub

     
End Class
