﻿
Imports System.Data
Partial Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Button1_Click(ByVal sender As Object, _
        ByVal e As System.EventArgs) _
        Handles Button1.Click

        ' define el servicio
        Dim sw As New localhost.Service

        ' necesitaremos estos objetos para 
        ' gestionar los datos
        Dim ds As DataSet
        Dim dr As DataRow

        Dim values As New ArrayList()

        ' utiliza el servicio Web para acceder a una 
        ' base de datos SQL Server
        Try
            ds = sw.Legajo(txtApellido.Text, txtNombre.Text)

            If ds.Tables(0).Rows.Count > 0 Then
                dr = ds.Tables(0).Rows(0)

                ' Muestra alguno de los datos del empleado
                values.Add("Dirección: " & dr("Address"))
                values.Add("Ciudad: " & dr("City"))
                values.Add("C.P.: " & dr("PostalCode"))
                values.Add("País: " & dr("Country"))

            Else
                ' no hay datos en el DataSet
                values.Add("No hay datos de ese empleado")
            End If
            ListBox1.DataSource = values
            ListBox1.DataBind()
        Catch ex As Exception
            MsgBox(AnalizarExcepción(ex))
        End Try


    End Sub
    ' Gestionar una excepción del servicio web 
    Private Function AnalizarExcepción(ByVal e As Exception) _
            As String

        ' bucle por las excepciones internas 
        Do While Not e.InnerException Is Nothing
            e = e.InnerException
        Loop

        ' Mensaje del error
        Return e.Message

    End Function


End Class
