﻿Module Module1
    ' Unidad05 Ej04
    ' varios ejemplos con métodos compartidos
    ' con la clase String
    Sub Main()

        Dim C1 As String = "Cadena C1"
        Dim C2 As String = "CADENA C2"

        ' Ejemplo de método Compare
        If [String].Compare(C1, C2) = 0 Then
            Debug.WriteLine("1. Las cadenas C1 y C2 son iguales")
        Else
            Debug.WriteLine("1. Las cadenas C1 y C2 son diferentes")
        End If

        ' Compare sobrecargado
        ' uso de subcadenas (compara las primeras 4 posiciones)
        ' pero diferencia mayúsculas de minúsculas
        If [String].Compare(C1, 1, C2, 1, 4) = 0 Then
            Debug.WriteLine("2. Las cadenas C1 y C2 son iguales")
        Else
            Debug.WriteLine("2. Las cadenas C1 y C2 son diferentes")
        End If

        ' En esta opción sobrecargada
        ' el sexto parámetro indica si no toma
        ' en cuenta la diferencia de minúsculas
        ' y mayúsculas
        If [String].Compare(C1, 1, C2, 1, 4, True) = 0 Then
            Debug.WriteLine("3. Las cadenas C1 y C2 son iguales")
        Else
            Debug.WriteLine("3. Las cadenas C1 y C2 son diferentes")
        End If

        ' compareOrdinal
        If [String].CompareOrdinal(C1, 1, C2, 1, 4) = 0 Then
            Debug.WriteLine("4. Las cadenas C1 y C2 son iguales")
        ElseIf [String].CompareOrdinal(C1, 1, C2, 1, 4) > 0 Then
            Debug.WriteLine("4. La cadena C2 es menor")
        Else
            Debug.WriteLine("4. La cadena C2 es mayor")
        End If

        ' Concatenación de dos objetos
        Debug.WriteLine([String].Concat(C1, C2))

        ' Crear un objeto C3 con el método COPY
        Dim C3 As Object

        C3 = [String].Copy(C1)
        ' es el mismo objeto??
        Debug.WriteLine([String].ReferenceEquals(C1, C3).ToString)
        ' false
        ' es el mismo objeto??
        Dim C4 As String = C1
        Debug.WriteLine([String].ReferenceEquals(C1, C4).ToString)
        'true

        If [String].Equals(C1, C3) And [String].Equals(C1, C4) Then
            Debug.WriteLine("5. Los tres objetos tienen el mismo " & _
            "contenido")
        End If

        Console.ReadLine()

    End Sub

End Module