﻿Module Module1
    ' Unidad 09 Ej03
    Sub Main()
        Dim iInt As Integer = 1234
        Dim sSng As Single = 0.12
        Dim dDec As Decimal = 123456789.123456
        Dim sShort As Short = 12345

        Try
            ' especificador estándar

            ' efecto del alineamiento
            Console.WriteLine("ALINEAMIENTO")

            ' Véase cómo quedan posicionado los dos 
            ' puntos después del número
            ' aquí alineamiento es menor que la longitud 
            ' del campo y no tiene efecto
            Console.WriteLine("{0} con especificador " & _
    " {{0,-4:F3}} es {0,-4:F3}:", 1)
            ' aquí alineamiento es menor que la longitud 
            ' del campo y no tiene efecto
            Console.WriteLine("{0} con especificador " & _
    "{{0,-5:F3}} es {0,-5:F3}:", 1)
            ' aquí alineamiento es mayor que la longitud 
            ' del campo y tiene efecto
            Console.WriteLine("{0} con especificador " & _
    "{{0,-6:F3}} es {0,-6:F3}:", 1)
            ' aquí alineamiento es mayor que la longitud 
            ' del campo y tiene efecto
            Console.WriteLine("{0} con especificador " & _
    " {{0,-7:F3}} es {0,-7:F3}:", 1)
            ' aquí alineamiento a la derecha y tiene efecto
            Console.WriteLine("{0} con especificador " & _
    " {{0,10:F3}} es {0,10:F3}:", 1)

            ' Especificador de moneda
            Console.WriteLine(vbLf & "MONEDA C")

            ' precisión predeterminada
            Console.WriteLine("{0} con especificador " & _
    "{{0:c}} es {0:c}", dDec)
            ' precisión 2
            Console.WriteLine("{0} con especificador " & _
    "{{0:C2}}es {0:C2}", dDec)
            ' precisión 4
            Console.WriteLine("{0} con especificador " & _
    "{{0:C4}}es {0:C4}", dDec)
            ' valor negativo
            Console.WriteLine("{0} con especificador " & _
    "{{0:C4}}es {0:C4}", -dDec)

            ' Especificador  decimal
            Console.WriteLine(vbLf & "DECIMAL D")

            ' precisión predeterminada
            Console.WriteLine("{0} con especificador " & _
    "{{0:D}} es {0:D}", sShort)
            ' precisión 2
            Console.WriteLine("{0} con especificador " & _
    "{{0:D2}}es {0:D2}", sShort)
            ' precisión 4 y negativo
            Console.WriteLine("{0} con especificador " & _
    "{{0:D4}}es {0:D4}", -sShort)

            ' Especificador  exponencial
            Console.WriteLine(vbLf & "EXPONENCIAL E")

            ' precisión predeterminada
            Console.WriteLine("{0} con especificador " & _
    "{{0:E}} es {0:E}", dDec)
            ' precisión 2
            Console.WriteLine("{0} con especificador " & _
    "{{0:E2}}es {0:E2}", dDec)
            ' precisión 4 y negativo
            Console.WriteLine("{0} con especificador " & _
    "{{0:E4}}es {0:E4}", -dDec)

            ' Especificador  coma fija
            Console.WriteLine(vbLf & "COMA FIJA F")

            ' precisión predeterminada
            Console.WriteLine("{0} con especificador " & _
    "{{0:F}} es {0:F}", dDec)
            ' precisión 2
            Console.WriteLine("{0} con especificador " & _
    "{{0:F2}}es {0:F2}", dDec)
            ' precisión 4 y negativo
            Console.WriteLine("{0} con especificador " & _
    "{{0:F4}}es {0:F4}", -dDec)

            ' Especificador  general
            Console.WriteLine(vbLf & "GENERAL G")

            ' precisión predeterminada
            Console.WriteLine("{0} con especificador " & _
    "{{0:G}} es {0:G}", dDec)
            ' precisión 2
            Console.WriteLine("{0} con especificador " & _
    "{{0:G2}}es {0:G2}", dDec)
            ' precisión 4 y negativo
            Console.WriteLine("{0} con especificador " & _
    "{{0:G4}}es {0:G4}", -dDec)

            ' Especificador  número
            Console.WriteLine(vbLf & "NÚMERO N")

            ' precisión predeterminada
            Console.WriteLine("{0} con especificador " & _
    "{{0:N}} es {0:N}", dDec)
            ' precisión 2
            Console.WriteLine("{0} con especificador " & _
    "{{0:N2}}es {0:N2}", dDec)
            ' precisión 4 y negativo
            Console.WriteLine("{0} con especificador " & _
    "{{0:N4}}es {0:N4}", -dDec)

            ' Especificador  porcentaje
            Console.WriteLine(vbLf & "PORCENTAJE P")

            ' precisión predeterminada
            Console.WriteLine("{0} con especificador " & _
    "{{0:P}} es {0:P}", sSng)
            ' precisión 2
            Console.WriteLine("{0} con especificador " & _
    "{{0:P2}}es {0:P2}", sSng)
            ' precisión 4 y negativo
            Console.WriteLine("{0} con especificador " & _
    "{{0:P4}}es {0:P4}", -sSng)

            ' Especificador  retorno
            Console.WriteLine(vbLf & "RETORNO R")

            ' precisión predeterminada
            Console.WriteLine("{0} con especificador " & _
    "{{0:R}} es {0:R}", sSng)
            ' precisión 2
            Console.WriteLine("{0} con especificador " & _
    "{{0:R2}}es {0:R2}", sSng)
            ' precisión 4 y negativo
            Console.WriteLine("{0} con especificador " & _
    "{{0:R4}}es {0:R4}", -sSng)

            ' Especificador  hexadecimal
            Console.WriteLine(vbLf & "HEXADECIMAL X")

            ' precisión predeterminada
            Console.WriteLine("{0} con especificador " & _
    "{{0:X}} es {0:X}", iInt)
            ' precisión 2 y negativo
            Console.WriteLine("{0} con especificador " & _
    "{{0:X2}}es {0:X2}", -iInt)
            ' precisión 4 y negativo
            Console.WriteLine("{0} con especificador " & _
    "{{0:x4}}es {0:x4}", -iInt)

        Catch ex As Exception
            Console.WriteLine("Error " & ex.Message)

        End Try
        Console.ReadLine()


    End Sub

End Module