﻿Imports System.IO
Module Module1
    ' Unidad 10 Ej 01
    Sub Main()
        Dim fb As FileStream
        Dim cIn As Integer
        ' matriz de 100 elementos
        Dim matBytes(99) As Byte
        ' para indexarse en la matriz
        Dim qBytes As Integer = 0
        ' Variable para el nombre del archivo  
        Dim sNom As String

        ' Se encierra todo en un bloque Try 
        ' para gestionar los errores de modo personalizado

        Try
            ' Se obtiene el nombre del archivo
            Console.Write("Nombre del archivo:")
            sNom = Console.ReadLine()

            ' Crea un flujo de bytes para el archivo texto.txt
            ' modo Create: si existe lo sobrescribe
            ' acceso: Write, para escritura

            fb = New FileStream(sNom, FileMode.Create, _
    FileAccess.Write)

            ' Introducción de datos desde la consola
            Console.Write("Introducir datos para el archivo {0}:", _
     sNom)
            cIn = Console.Read()
            ' Proceso de lectura 
            While (cIn <> 13 And qBytes < matBytes.Length)
                matBytes(qBytes) = Convert.ToByte(cIn)
                qBytes += 1
                cIn = Console.Read()
            End While

            ' Proceso de escritura
            fb.Write(matBytes, 0, qBytes)

        Catch ex As IOException
            Console.WriteLine("Se detecta un error IO " + _
     ex.Message)
        Catch ex As Exception
            Console.WriteLine("Se detecta un error genérico " + _
    ex.Message)

        Finally
            ' Cerrar el flujo de datos que utiliza el archivo
            If (Not fb Is Nothing) Then fb.Close()
        End Try
        Console.Read()
    End Sub

End Module