﻿Imports System.IO
Module Module1
    ' Unidad 10 Ej 02
    Sub Main()
        Dim fb As FileStream
        ' matriz de 100 elementos
        Dim matBytes(99) As Byte
        ' matriz de 100 elementos
        Dim matChar(99) As Char
        ' para indexarse en la matriz
        Dim qBytes As Integer = 0
        ' Variable para el nombre del archivo  
        Dim sNom As String
        ' Variable para el contenido del archivo  
        Dim sDatos As String


        ' Se encierra todo en un bloque Try 
        ' para gestionar los errores de modo personalizado
        Try
            ' Se obtiene el nombre del archivo
            Console.Write("Nombre del archivo:")
            sNom = Console.ReadLine()

            ' Crea un flujo de bytes para el archivo texto.txt
            ' modo Open: si no existe genera un error  
            ' acceso: Read, para lectura

            fb = New FileStream(sNom, FileMode.Open, _
     FileAccess.Read)

            ' método read lee el archivo, coloca el flujo de datos
            ' en matBytes. El parámetro con valor 0 indica el 
            ' desplazamiento en el flujo de datos y el último
            ' parámetro indica la cantidad máxima de bytes que se
            ' pueden leer en cada acceso (la lectura real
            ' queda registrada en la variable qBytes)
            qBytes = fb.Read(matBytes, 0, matBytes.Length)

            ' La matriz la debemos convertir a cadena
            ' se copia una matriz Byte en una matriz Char
            Array.Copy(matBytes, matChar, matBytes.Length)

            ' se utiliza como longitud la 
            ' cantidad real de bytes leídos (qBytes)
            sDatos = New String(matChar, 0, qBytes)

            ' Impresión de datos leídos desde el archivo
            Console.Write("Contenido leído del archivo {0}: {1}", _
    sNom, sDatos)


        Catch ex As IOException
            Console.WriteLine("Se detecta un error IO " + _
    ex.Message)
        Catch ex As Exception
            Console.WriteLine("Se detecta un error genérico " + _
    ex.Message)

        Finally
            ' Cerrar el flujo de datos que utiliza el archivo
            If (Not fb Is Nothing) Then fb.Close()
        End Try
        Console.Read()
    End Sub

End Module