﻿Imports System.IO
Module Module1
    ' Unidad 10 Ej 09
    Sub Main()
        Dim DirInfo As DirectoryInfo
        Dim listaDir() As String
        Dim listaArch() As String
        Dim sIn As String
        Dim sOp As String
        Dim sUnidades As String

        ' Datos de las unidades lógicas
        ' se obtiene del objeto Directory
        For Each sUnidades In Directory.GetLogicalDrives
            Console.WriteLine("Unidades lógicas {0}", sUnidades)
        Next

        Console.WriteLine("Elegir una ruta de acceso:")
        sIn = Console.ReadLine()

        While (Not String.IsNullOrEmpty(sIn))
            Console.WriteLine("Directorio: {0}", sIn)

            ' obtiene los subdirectorios y los archivos
            ' que hay debajo del directorio
            listaDir = obtenerDirectorios(sIn)
            listaArch = obtenerArchivos(sIn)

            ' lista el contenido
            listar(listaDir, listaArch)

            ' Muestra las opciones disponibles
            Console.WriteLine("Nro. directorio a explorar, ")
            Console.WriteLine("0 = nueva ruta de acceso, ")
            Console.WriteLine("P = directorio nivel superior, ")
            Console.WriteLine("Intro salir:")

            sOp = Console.ReadLine()
            If (Not String.IsNullOrEmpty(sOp)) Then
                Select Case sOp
                    Case "0"
                        ' elige una ruta de acceso cualquiera
                        Console.WriteLine("Elegir una ruta de" & _
         " acceso:")
                        sIn = Console.ReadLine()
                    Case "P"
                        ' busca los datos del directorio padre 
                        DirInfo = Directory.GetParent(sIn)
                        sIn = DirInfo.FullName
                    Case (listaDir.Length <= Convert.ToInt16(sOp))
                        ' uno de los subdirectorios 
                        sIn = listaDir(Convert.ToInt16(sOp) - 1)
                    Case Else
                        ' cualquier valor inesperado
                        ' asume la carpeta vigente
                        sIn = Directory.GetCurrentDirectory
                End Select
            End If
        End While
        Console.ReadLine()


    End Sub
    Public Function obtenerDirectorios(ByVal sIn As String) _
   As String()

        obtenerDirectorios = Directory.GetDirectories(sIn)

    End Function
    Public Function obtenerArchivos(ByVal sIn As String) As String()

        obtenerArchivos = Directory.GetFiles(sIn)

    End Function
    Public Sub listar(ByVal listaDir As String(), _
   ByVal listaArch As String())

        Dim str As String
        Dim i As Short

        Console.WriteLine("Contenido del directorio ")

        For Each str In listaDir
            'reservamos el 0 para cambiar de ruta de acceso
            ' por eso desplazamos los índices en 1
            i += 1
            Console.WriteLine(" {0} Subdir. {1} —> " & _
    "Últ. acceso {2:(dd/MM hh:mm:ss)} ", i, str, _
    Directory.GetLastAccessTime(str))
        Next

        Console.WriteLine("Archivos del directorio ")
        For Each str In listaArch
            ' Del objeto File podemos obtener información de
            ' atributos y estado del archivo
            Console.WriteLine(" Archivo {0} —> " & _
    "Últ. acceso {1:(dd/MM hh:mm:ss)}", str, _
    File.GetLastAccessTime(str))

        Next


    End Sub

End Module
