﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
     

    End Sub

    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As System.Object, _
                         ByVal e As System.EventArgs) _
                         Handles ListBox1.SelectedIndexChanged


        Select Case ListBox1.SelectedItem


            Case "Productos de categoría x"
                Dim db As New DataClasses1DataContext
                Dim productos = From prod In db.Products _
                          Where prod.CategoryID = TextBox1.Text _
                          Order By prod.ProductName _
                Select prod

                DataGridView1.DataSource = productos

            Case "Pedidos de productos de categoría x"
                Dim db As New DataClasses1DataContext
                Dim productos = From ord In db.Order_Details, _
                                prod In db.Products, _
                                cat In db.Categories _
                                Where ord.ProductID = prod.ProductID And _
                                prod.CategoryID = TextBox1.Text _
                                Order By ord.OrderID _
                Select ord.OrderID, prod.ProductName, cat.CategoryName
                DataGridView1.DataSource = productos

            Case "Productos de un pedido x"
                Dim db As New DataClasses1DataContext

                Dim productos = db.CustOrdersDetail(TextBox1.Text)

                DataGridView1.DataSource = productos

            Case "Actualizar producto x"
                Dim db As New DataClasses1DataContext
                Dim productos = From prod In db.Products _
                          Order By prod.ProductName _
                Select prod

                For Each prod In productos
                    If prod.ProductID = TextBox1.Text Then
                        'Elimina un producto
                        db.Products.DeleteOnSubmit(prod)
                    Else
                        ' actualiza una propiedad determinada
                        prod.UnitsInStock += 1
                    End If
                Next

                Try
                    ' se sincronizan todos los cambios
                    db.SubmitChanges()
                Catch ex As Exception
                    Console.WriteLine(ex)
                End Try

        End Select
    End Sub
End Class
